library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity tmpl_interrupt is
	generic (
		AUTO_CLOCK_SINK_CLOCK_RATE : string := "-1"
	);
	port (
		clk       : in  std_logic                     := '0';
		irq_input : in  std_logic_vector(31 downto 0) := (others => '0');
		reset     : in  std_logic                     := '0';
		irq_0_out : out std_logic;
		irq_1_out : out std_logic;
		irq_2_out : out std_logic;
		irq_3_out : out std_logic;
		irq_4_out : out std_logic;
		irq_5_out : out std_logic;
		irq_6_out : out std_logic;
		irq_7_out : out std_logic;
		irq_8_out : out std_logic;
		irq_9_out : out std_logic;
		irq_10_out : out std_logic;
		irq_11_out : out std_logic;
		irq_12_out : out std_logic;
		irq_13_out : out std_logic;
		irq_14_out : out std_logic;
		irq_15_out : out std_logic;
		irq_16_out : out std_logic;
		irq_17_out : out std_logic;
		irq_18_out : out std_logic;
		irq_19_out : out std_logic;
		irq_20_out : out std_logic;
		irq_21_out : out std_logic;
		irq_22_out : out std_logic;
		irq_23_out : out std_logic;
		irq_24_out : out std_logic;
		irq_25_out : out std_logic;
		irq_26_out : out std_logic;
		irq_27_out : out std_logic;
		irq_28_out : out std_logic;
		irq_29_out : out std_logic;
		irq_30_out : out std_logic;
		irq_31_out : out std_logic
	);
end entity tmpl_interrupt;

architecture rtl of tmpl_interrupt is
begin
	process (clk, reset) is
	begin
		if (reset = '1') then
			irq_0_out <= '0';
			irq_1_out <= '0';
			irq_2_out <= '0';
			irq_3_out <= '0';
			irq_4_out <= '0';
			irq_5_out <= '0';
			irq_6_out <= '0';
			irq_7_out <= '0';
			irq_8_out <= '0';
			irq_9_out <= '0';
			irq_10_out <= '0';
			irq_11_out <= '0';
			irq_12_out <= '0';
			irq_13_out <= '0';
			irq_14_out <= '0';
			irq_15_out <= '0';
			irq_16_out <= '0';
			irq_17_out <= '0';
			irq_18_out <= '0';
			irq_19_out <= '0';
			irq_20_out <= '0';
			irq_21_out <= '0';
			irq_22_out <= '0';
			irq_23_out <= '0';
			irq_24_out <= '0';
			irq_25_out <= '0';
			irq_26_out <= '0';
			irq_27_out <= '0';
			irq_28_out <= '0';
			irq_29_out <= '0';
			irq_30_out <= '0';
			irq_31_out <= '0';
		elsif (clk'event and clk = '1') then	
			irq_0_out <= irq_input(0);
			irq_1_out <= irq_input(1);
			irq_2_out <= irq_input(2);
			irq_3_out <= irq_input(3);
			irq_4_out <= irq_input(4);
			irq_5_out <= irq_input(5);
			irq_6_out <= irq_input(6);
			irq_7_out <= irq_input(7);
			irq_8_out <= irq_input(8);
			irq_9_out <= irq_input(9);
			irq_10_out <= irq_input(10);
			irq_11_out <= irq_input(11);
			irq_12_out <= irq_input(12);
			irq_13_out <= irq_input(13);
			irq_14_out <= irq_input(14);
			irq_15_out <= irq_input(15);
			irq_16_out <= irq_input(16);
			irq_17_out <= irq_input(17);
			irq_18_out <= irq_input(18);
			irq_19_out <= irq_input(19);
			irq_20_out <= irq_input(20);
			irq_21_out <= irq_input(21);
			irq_22_out <= irq_input(22);
			irq_23_out <= irq_input(23);
			irq_24_out <= irq_input(24);
			irq_25_out <= irq_input(25);
			irq_26_out <= irq_input(26);
			irq_27_out <= irq_input(27);
			irq_28_out <= irq_input(28);
			irq_29_out <= irq_input(29);
			irq_30_out <= irq_input(30);
			irq_31_out <= irq_input(31);
		end if;	
	end process;
end architecture rtl;
