@echo off
SET TOOL_VER="$(TOOL_VER)"
SET QUARTUS_DIR="$(QUARTUS)"
SET WORKING_FOLDER="$(WORKING_FOLDER)"
SET NIOS2_KIT="$(NIOS2_KIT)"
SET PROJECT_OUT_FOLDER="$(PROJECT_OUT_FOLDER)\"

echo "********************* Running Quartus Shell ***************************************"
echo "***********************************************************************************"
echo "********************* Set SCRIPT Name *********************************************"
SET SCRIPT_NAME=%WORKING_FOLDER%\qsys_gen_script.tcl
echo "******** Set SCRIPT Name  %SCRIPT_NAME%"
SET QSHELL_SCRIPT_NAME=%WORKING_FOLDER%\nios_prj_script.tcl
echo "******** Set QSHELL SCRIPT Name  %QSHELL_SCRIPT_NAME%"
echo "***********************************************************************************"
echo "********************* Set Search Path *********************************************"
SET QSYS_SHELL_DIR=%QUARTUS_DIR%\bin64
SET QSYS_BIN_DIR=%QUARTUS_DIR%\sopc_builder\bin
echo "********* QSYS_BIN_DIR - %QSYS_BIN_DIR%"
echo "***********************************************************************************"
echo "*************** RUN Quartus Shell *************************************************"
%QSYS_SHELL_DIR%\quartus_sh.exe -t %QSHELL_SCRIPT_NAME% -tool_version %TOOL_VER%^
 														-quartus_dir %QUARTUS_DIR%^
 														-cache_dir %WORKING_FOLDER%^
 														-nios2kit_dir %NIOS2_KIT%^
 														-proj_out_dir %PROJECT_OUT_FOLDER% > "$(WORKING_FOLDER)\nios2_cpu.out"

echo "****************** END ************************************************************"